<?php

/**
 * @copyright  https://github.com/UsabilityDynamics/zoom-api-php-client/blob/master/LICENSE
 */
namespace Zoom\Endpoint\Oauth;

use Zoom\Interfaces\Oauth\Request;

/**
 * Class Reports
 * @package Zoom\Interfaces
 */
class Reports extends Request {

    /**
     * Meetings constructor.
     * @param $accountId
     * @param $clientId
     * @param $clientSecret
     */
    public function __construct($accountId, $clientId, $clientSecret) {
        parent::__construct($accountId, $clientId, $clientSecret);
    }

    /**
     * Meeting Participants
     *
     * @param $meetingUUID
     * @param array $query
     * @return array|mixed
     */
    public function meetingParticipants(string $meetingUUID, array $query = []) {
        return $this->get("report/meetings/{$meetingUUID}/participants", $query);
    }

}