<?php
/**
* @package RSform!Pro
* @copyright (C) www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die('Restricted access');

class TableRSForm_Google_Calendar extends JTable
{
	public $form_id = null;

	public $gc_published = 0;
	public $gc_calendar_id = 'primary';
	public $gc_use_recurrence = 0;
	public $gc_debug = 0;
	public $gc_mappings = '';
		
	/**
	 * Constructor
	 *
	 * @param object Database connector object
	 */
	public function __construct(& $db)
	{
		parent::__construct('#__rsform_google_calendar', 'form_id', $db);
	}

	public function check()
	{
		if (empty($this->gc_calendar_id))
		{
			$this->gc_calendar_id = 'primary';
		}

		$this->gc_calendar_id = trim($this->gc_calendar_id);

		if (is_array($this->gc_mappings))
		{
			$this->gc_mappings = serialize($this->gc_mappings);
		}

		return true;
	}

	public function hasPrimaryKey()
	{
		$db 	= $this->getDbo();
		$key 	= $this->getKeyName();
		$table	= $this->getTableName();

		$query = $db->getQuery(true)
			->select($db->qn($key))
			->from($db->qn($table))
			->where($db->qn($key) . ' = ' . $db->q($this->{$key}));

		return $db->setQuery($query)->loadResult() !== null;
	}
}