<?php
/**
* @package RSform!Pro
* @copyright (C) 2015 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

define('RSFORM_FIELD_PAYMENT_PAGSEGURO', 502);

/**
 * RSForm! Pro system plugin
 */
class plgSystemRsfppagseguropayment extends JPlugin
{
	protected $autoloadLanguage = true;

	protected $componentId = RSFORM_FIELD_PAYMENT_PAGSEGURO;
	protected $componentValue = 'pagseguro';

	public function onRsformBackendAfterCreateFieldGroups(&$fieldGroups, $self)
	{
		$formId = JFactory::getApplication()->input->getInt('formId');
		$exists = RSFormProHelper::componentExists($formId, RSFORM_FIELD_PAYMENT_PAGSEGURO);

		$fieldGroups['payment']->fields[] = (object) array(
			'id' 	=> RSFORM_FIELD_PAYMENT_PAGSEGURO,
			'name' 	=> JText::_('RSFP_PAGSEGURO_COMPONENT'),
			'icon'  => 'rsficon rsficon-coin-dollar',
			'exists' => $exists ? $exists[0] : false
		);
	}

	public function onRsformBackendAfterCreateComponentPreview($args = array())
    {
		if ($args['ComponentTypeName'] == 'pagseguro')
		{
			$args['out'] = '<span class="rsficon rsficon-coin-dollar" style="font-size:24px;margin-right:5px"></span> '.$args['data']['LABEL'];
		}
	}

	public function onRsformBackendAfterShowFormEditTabsTab()
	{
		?>
        <li><a href="javascript: void(0);" id="rsfppagseguro"><span class="rsficon rsficon-coin-dollar"></span><span class="inner-text"><?php echo JText::_('RSFP_PAGSEGURO_LABEL'); ?></span></a></li>
		<?php
	}

	protected function getTable()
	{
		return JTable::getInstance('RSForm_Pagseguro', 'Table');
	}

	public function onRsformBackendAfterShowFormEditTabs()
    {
	    $formId = JFactory::getApplication()->input->getInt('formId', 0);
	    $row    = $this->getTable();

	    if (!$row)
	    {
		    return;
	    }

	    $row->load($formId);

	    if ($row->vars)
	    {
		    $row->vars = unserialize($row->vars);
	    }

        $fields = $this->standardFields();
        ?>
        <div id="pagsegurodiv">
            <table class="table table-bordered">
                <?php foreach ($fields as $field) { ?>
                <tr>
                    <td width="80" align="right" nowrap="nowrap" class="key" valign="top">
			            <?php echo JText::_('PLG_SYSTEM_RSFPPAGSEGUROPAYMENT_FIELD_' . $field); ?>
                    </td>
                    <td valign="top">
                        <input name="pagseguro_vars[<?php echo RSFormProHelper::htmlEscape($field); ?>]" id="pagseguro_vars<?php echo RSFormProHelper::htmlEscape($field); ?>" value="<?php echo RSFormProHelper::htmlEscape(isset($row->vars[$field]) ? $row->vars[$field] : ''); ?>" type="text" class="rs_inp rs_80"  data-delimiter=" " data-placeholders="display" />
                    </td>
                </tr>
                <?php } ?>
            </table>
        </div>
        <?php
    }

    private function standardFields()
    {
	    return array('name', 'email', 'areacode', 'phonenumber');
    }

	public function onRsformFormSave($form)
	{
		try
		{
			$application     = JFactory::getApplication();
			$data            = array();
			$data['vars']    = $application->input->get('pagseguro_vars', array(), 'array');
			$data['form_id'] = $application->input->getInt('formId', 0);
			$row             = $this->getTable();

			if (!$row)
			{
				throw new Exception ('Could not get an instance of the PagSeguro Table');
			}
			if (!$row->save($data))
			{
				throw new Exception($row->getError());
			}
		}
		catch (Exception $e)
		{
			$application->enqueueMessage($e->getMessage(), 'error');
		}

		return true;
	}

	public function onRsformBackendFormCopy($args)
	{
		$formId = $args['formId'];
		$newFormId = $args['newFormId'];

		if ($row = $this->getTable())
		{
			if ($row->load($formId))
			{
			    $row->form_id = $newFormId;
			    if ($row->check())
                {
	                $row->store();
                }
			}
		}
	}

	public function onRsformDefineHiddenComponents(&$hiddenComponents)
	{
		$hiddenComponents[] = $this->componentId;
	}

	public function onRsformBackendAfterShowConfigurationTabs($tabs)
    {
		$tabs->addTitle(JText::_('RSFP_PAGSEGURO_LABEL'), 'page-pagseguro');
		$tabs->addContent($this->configurationScreen());
	}
	
	protected function configurationScreen()
    {
		ob_start();

		JForm::addFormPath(__DIR__ . '/forms');

		$form = JForm::getInstance( 'plg_system_rsfppagseguro.configuration', 'configuration', array('control' => 'rsformConfig'), false, false );
		$form->bind($this->loadFormData());

		?>
		<div id="page-pagseguro" class="form-horizontal">
			<?php
			foreach ($form->getFieldsets() as $fieldset)
			{
				if ($fields = $form->getFieldset($fieldset->name))
				{
					foreach ($fields as $field)
					{
						echo $field->renderField();
					}
				}
			}
			?>
		</div>
		<?php

		$contents = ob_get_contents();
		ob_end_clean();

		return $contents;
	}

	private function loadFormData()
	{
		$data 	= array();
		$db 	= JFactory::getDbo();

		$query = $db->getQuery(true)
			->select('*')
			->from($db->qn('#__rsform_config'))
			->where($db->qn('SettingName') . ' LIKE ' . $db->q('pagseguro.%', false));
		if ($results = $db->setQuery($query)->loadObjectList())
		{
			foreach ($results as $result)
			{
				$data[$result->SettingName] = $result->SettingValue;
			}
		}

		return $data;
	}
	
	public function onRsformGetPayment(&$items, $formId)
    {
		if ($components = RSFormProHelper::componentExists($formId, $this->componentId))
		{
			$data = RSFormProHelper::getComponentProperties($components[0]);
			
			$item 			= new stdClass();
			$item->value 	= $this->componentValue;
			$item->text 	= $data['LABEL'];
			
			// add to array
			$items[] = $item;
		}
	}
	
	public function onRsformDoPayment($payValue, $formId, $SubmissionId, $price, $products, $code)
    {
		// execute only for our plugin
		if ($payValue != $this->componentValue)
        {
            return;
        }
		
		if ($price > 0) {
			$app	= JFactory::getApplication();
			$email	= RSFormProHelper::getConfig('pagseguro.email');
			$token	= RSFormProHelper::getConfig('pagseguro.token');

			try
            {
	            if (empty($email))
	            {
		            throw new Exception(JText::_('PLG_SYSTEM_RSFPPAGSEGUROPAYMENT_NO_EMAIL_CONFIGURED'));
	            }

	            if (empty($token))
	            {
		            throw new Exception(JText::_('PLG_SYSTEM_RSFPPAGSEGUROPAYMENT_NO_TOKEN_CONFIGURED'));
	            }

	            $instance = RSFormProPagSeguro::getInstance();
	            $paymentRequest =& $instance->sale;
	            $credentials = new PagSeguroAccountCredentials($email, $token);

	            // We have custom items
	            if ($instance->items)
                {
                    foreach ($instance->items as $item)
                    {
                        call_user_func_array(array($paymentRequest, 'addItem'), $item);
                    }
                }
                else
                {
	                $paymentRequest->addItem('0001', implode(', ', $products), 1, $this->number_format($price));
                }

	            $paymentRequest->setReference($code);
	            $paymentRequest->addParameter('notificationURL', JUri::root() . 'index.php?option=com_rsform&formId=' . $formId . '&task=plugin&plugin_task=pagseguro.notify');

	            $row = $this->getTable();

	            if ($row && $row->load($formId) && $row->vars)
	            {
		            $row->vars = unserialize($row->vars);

		            if (is_array($row->vars))
                    {
                        list($replace, $with) = RSFormProHelper::getReplacements($SubmissionId);
                        $senderVars = $this->standardFields();

                        foreach ($row->vars as $pagSeguroVar => $placeholder)
                        {
                            $senderVars[array_search($pagSeguroVar, $senderVars)] = str_replace($replace, $with, $placeholder);
                        }

                        call_user_func_array(array($paymentRequest, 'setSender'), $senderVars);
                    }
	            }

	            if (RSFormProHelper::getConfig('pagseguro.lightbox'))
                {
	                $code = $paymentRequest->register($credentials, true);

	                $app->redirect(JRoute::_('index.php?option=com_rsform&formId=' . $formId . '&task=plugin&plugin_task=pagseguro.lightbox&code=' . urlencode($code), false));
                }
                else
                {
	                $url = $paymentRequest->register($credentials);
	                $app->redirect($url);
                }
            }
            catch (PagSeguroServiceException $e)
            {
	            $app->enqueueMessage('PagSeguro: '.$e->getMessage(),'error');
            }
            catch (Exception $e)
            {
	            $app->enqueueMessage($e->getMessage(), 'error');
            }
		}
	}
	
	public function onRsformFrontendSwitchTasks()
    {
		$app	= JFactory::getApplication();
		$input	= $app->input;
		$formId	= $input->getInt('formId',0);
	    $task   = $input->getString('plugin_task','');
		
		if ($task == 'pagseguro.notify')
		{
			$email	= RSFormProHelper::getConfig('pagseguro.email');
			$token	= RSFormProHelper::getConfig('pagseguro.token');
			$code	= $input->getString('notificationCode','');
			$type	= $input->getString('notificationType','');
			
			if (empty($email) || empty($token) || empty($code) || empty($type))
			{
				return;
			}
			
			try
            {
                // This loads our library
	            $instance = RSFormProPagSeguro::getInstance();
				
				$notificationType = new PagSeguroNotificationType($type);
				$type = $notificationType->getTypeFromValue();
				
				if ($type == 'TRANSACTION')
				{
					$credentials = new PagSeguroAccountCredentials($email, $token);
					$transaction = PagSeguroNotificationService::checkTransaction($credentials, $code);
					$reff		 = $transaction->getReference();
					
					$statusPagSeguro	= $transaction->getStatus()->getValue();
					$transactionStatus	= new PagSeguroTransactionStatus($statusPagSeguro);
					$status				= $transactionStatus->getTypeFromValue();
					
					if (strtolower($status) == 'paid')
					{
						$db = JFactory::getDbo();
						$query = $db->getQuery(true);
						$query->select($db->qn('SubmissionId'))
							->from($db->qn('#__rsform_submissions', 's'))
							->where($db->qn('s.FormId') . ' = ' . $db->q($formId))
							->where('MD5(CONCAT(' . $db->qn('s.SubmissionId') . ',' . $db->qn('s.DateSubmitted') . ')) = ' . $db->q($reff));
						$db->setQuery($query);
						if ($SubmissionId = $db->loadResult())
						{
							$query = $db->getQuery(true);
							$query->update($db->qn('#__rsform_submission_values'))
								->set($db->qn('FieldValue') . ' = ' . $db->q(1))
								->where($db->qn('FieldName') . ' = ' . $db->q('_STATUS'))
								->where($db->qn('FormId') . ' = ' . $db->q($formId))
								->where($db->qn('SubmissionId') . ' = ' . $db->q($SubmissionId));
							$db->setQuery($query);
							$db->execute();

							// Add Transaction Code to _TRANSACTION_ID field
							if ($transactionCode = $transaction->getCode())
							{
								$query = $db->getQuery(true);
								$query->update($db->qn('#__rsform_submission_values'))
									->set($db->qn('FieldValue') . ' = ' . $db->q($transactionCode))
									->where($db->qn('FieldName') . ' = ' . $db->q('_TRANSACTION_ID'))
									->where($db->qn('FormId') . ' = ' . $db->q($formId))
									->where($db->qn('SubmissionId') . ' = ' . $db->q($SubmissionId));
								$db->setQuery($query);
								$db->execute();
							}
							
							$app->triggerEvent('onRsformAfterConfirmPayment', array($SubmissionId));
							echo JText::_('RSFP_PAGSEGURO_PAYMENT_ACCEPTED');
							$app->close();
						}
					}
				}
			}
			catch (PagSeguroServiceException $e)
            {
                echo $e->getMessage();
                $app->close();
            }
		}
		elseif ($task == 'pagseguro.lightbox')
        {
            $code = $input->getString('code');

	        // This loads our library
	        $instance = RSFormProPagSeguro::getInstance();

	        RSFormProAssets::addScript($instance->script);

	        JText::script('PLG_SYSTEM_RSFPPAGSEGUROPAYMENT_LIGHTBOX_PAYMENT_SUCCESS');
	        JText::script('PLG_SYSTEM_RSFPPAGSEGUROPAYMENT_LIGHTBOX_PAYMENT_ABORTED');
?>
<div id="rsform-pagseguro-message"><?php echo JText::_('PLG_SYSTEM_RSFPPAGSEGUROPAYMENT_LIGHTBOX_IS_LOADING'); ?></div>
<script>
PagSeguroLightbox(<?php echo json_encode($code); ?>, {
    success: function(transactionCode) {
        document.getElementById('rsform-pagseguro-message').innerHTML = Joomla.Text._('PLG_SYSTEM_RSFPPAGSEGUROPAYMENT_LIGHTBOX_PAYMENT_SUCCESS');

        window.setTimeout(function(){
           document.location.href = <?php echo json_encode(JRoute::_('index.php?option=com_rsform&formId=' . $formId . '&task=plugin&plugin_task=pagseguro.return&formId=' . urlencode($formId), false)); ?>
        }, 3000);
    },
    abort: function(error) {
        document.getElementById('rsform-pagseguro-message').innerHTML = Joomla.Text._('PLG_SYSTEM_RSFPPAGSEGUROPAYMENT_LIGHTBOX_PAYMENT_ABORTED');
    }
});
</script>
<?php
        }
        elseif ($task == 'pagseguro.return')
        {
	        // Get session object
	        $session = JFactory::getSession();
	        // Get data from session
	        $formparams = $session->get('com_rsform.formparams.formId'.$formId);
	        if ($formparams && $formparams->redirectUrl)
	        {
		        // Mark form as processed
		        $formparams->formProcessed = true;

		        // Store new session data
		        $session->set('com_rsform.formparams.formId'.$formId, $formparams);

		        // Redirect
		        $app->redirect($formparams->redirectUrl);
	        }
        }
	}

	public function onRsformFormDelete($formId)
    {
		if ($row = $this->getTable())
		{
			$row->delete($formId);
		}
	}

	public function onRsformFormBackup($form, $xml, $fields)
	{
		if ($row = $this->getTable())
		{
			if ($row->load($form->FormId))
			{
				$row->check();

				$data = $row->getProperties();
				unset($data['form_id']);

				$xml->add('pagseguro');
				foreach ($data as $property => $value)
				{
					$xml->add($property, $value);
				}
				$xml->add('/pagseguro');
			}
		}
	}

	public function onRsformFormRestore($form, $xml, $fields)
	{
		if (isset($xml->pagseguro))
		{
			$data = array(
				'form_id' => $form->FormId
			);

			foreach ($xml->pagseguro->children() as $property => $value)
			{
				$data[$property] = (string) $value;
			}

			$row = $this->getTable();
			$row->save($data);
		}
	}

	public function onRsformBackendFormRestoreTruncate()
	{
		JFactory::getDbo()->truncateTable('#__rsform_pagseguro');
	}

	protected function _getFields($formId)
	{
		$db    = JFactory::getDbo();
		$query = $db->getQuery(true)
			->select($db->qn('p.PropertyValue'))
			->from($db->qn('#__rsform_components', 'c'))
			->join('LEFT', $db->qn('#__rsform_properties', 'p') . ' ON (' . $db->qn('c.ComponentId') . '=' . $db->qn('p.ComponentId') . ')')
			->where($db->qn('c.FormId') . '=' . $db->q($formId))
			->where($db->qn('p.PropertyName') . '=' . $db->q('NAME'))
			->order($db->qn('c.Order') . ' ' . $db->escape('ASC'));

		return $db->setQuery($query)->loadColumn();
	}

	private function number_format($val)
	{
		return number_format($val, 2, '.', '');
	}
}

class RSFormProPagSeguro
{
    public $script;

	public $items = array();

	/* @var PagSeguroPaymentRequest */
	public $sale;

	public static function getInstance()
	{
		static $inst;
		if (!$inst)
		{
			$inst = new RSFormProPagSeguro;
		}

		return $inst;
	}

	public function __construct()
	{
		require_once JPATH_ADMINISTRATOR . '/components/com_rsform/helpers/pagseguro/PagSeguroLibrary.php';

		$enviroment = (int) RSFormProHelper::getConfig('pagseguro.mode') ? 'production' : 'sandbox';
		PagSeguroConfig::setEnvironment($enviroment);

		if ($enviroment === 'production')
		{
			$this->script = 'https://stc.pagseguro.uol.com.br/pagseguro/api/v2/checkout/pagseguro.lightbox.js';
		}
		else
		{
			$this->script = 'https://stc.sandbox.pagseguro.uol.com.br/pagseguro/api/v2/checkout/pagseguro.lightbox.js';
		}

		$this->sale = new PagSeguroPaymentRequest();

		// Defaults
		$this->sale->setCurrency(RSFormProHelper::getConfig('payment.currency'));
	}
}