<?php
/**
 * @package RSForm! Pro
 * @copyright (C) 2007-2022 www.rsjoomla.com
 * @license GPL, http://www.gnu.org/licenses/gpl-3.0.html
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class plgRsfinderRsformInstallerScript
{

	protected static $minJoomla = '4.0.0';
	/**
	 * @param $type
	 * @param $parent
	 *
	 * @return bool
	 */
	public function preflight($type, $parent) {
		if ($type == 'uninstall') {
			return true;
		}
		try {
			$jversion = new JVersion();

			if (!$jversion->isCompatible(static::$minJoomla))
			{
				throw new Exception('Please upgrade to at least Joomla! ' . static::$minJoomla . ' before continuing!');
			}
			
			if (!file_exists(JPATH_ADMINISTRATOR.'/components/com_rsform/helpers/version.php')) {
				throw new Exception('Please install RSForm! Pro first before you attempt to install this plugin.');
				
			}
			
			// Check version matches
			require_once JPATH_ADMINISTRATOR.'/components/com_rsform/helpers/version.php';
			
			if (!class_exists('RSFormProVersion') || version_compare((string) new RSFormProVersion, '3.0.0', '<'))
			{
				throw new Exception('Please upgrade RSForm! Pro to at least version 3.0.0 before continuing!');
			}
			
		} catch (Exception $e) {
			JFactory::getApplication()->enqueueMessage($e->getMessage(), 'error');
			return false;
		}

		return true;
	}
}